'use strict';

exports.__esModule = true;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _Project = require('../Project');

var _Project2 = _interopRequireDefault(_Project);

var _messages = require('./messages');

var messages = _interopRequireWildcard(_messages);

var _errors = require('./errors');

var _logger = require('./logger');

var logger = _interopRequireWildcard(_logger);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(project) {
    var workspaces, projectDependencies, _ref2, depGraph, projectIsValid, _iterator, _isArray, _i, _ref3, workspace, depName;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return project.getWorkspaces();

          case 2:
            workspaces = _context.sent;
            projectDependencies = project.pkg.getAllDependencies();
            _context.next = 6;
            return project.getDependencyGraph(workspaces);

          case 6:
            _ref2 = _context.sent;
            depGraph = _ref2.graph;
            projectIsValid = true;

            // Workspaces should never appear as dependencies in the Project config

            _iterator = workspaces, _isArray = Array.isArray(_iterator), _i = 0, _iterator = _isArray ? _iterator : (0, _getIterator3.default)(_iterator);

          case 10:
            if (!_isArray) {
              _context.next = 16;
              break;
            }

            if (!(_i >= _iterator.length)) {
              _context.next = 13;
              break;
            }

            return _context.abrupt('break', 25);

          case 13:
            _ref3 = _iterator[_i++];
            _context.next = 20;
            break;

          case 16:
            _i = _iterator.next();

            if (!_i.done) {
              _context.next = 19;
              break;
            }

            return _context.abrupt('break', 25);

          case 19:
            _ref3 = _i.value;

          case 20:
            workspace = _ref3;
            depName = workspace.pkg.config.getName();

            if (projectDependencies.has(depName)) {
              logger.error(messages.projectCannotDependOnWorkspace(depName));
              projectIsValid = false;
            }

          case 23:
            _context.next = 10;
            break;

          case 25:
            return _context.abrupt('return', projectIsValid);

          case 26:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  function validateProject(_x) {
    return _ref.apply(this, arguments);
  }

  return validateProject;
}();